/// @author Alexander Rykovanov 2013
/// @email rykovanov.as@gmail.com
/// @brief Well known node browse names.
/// @license GNU LGPL
///
/// Distributed under the GNU LGPL License
/// (See accompanying file LICENSE or copy at
/// http://www.gnu.org/licenses/lgpl.html)
///

#ifndef OPC_UA_STRINGS_H
#define OPC_UA_STRINGS_H

namespace OpcUa
{
namespace Names
{
const char AddNodesItem[]    = "AddNodesItem";
const char AddReferencesItem[] = "AddReferencesItem";
const char Aggregates[]      = "Aggregates";
const char AggregateFunctions[] = "AggregateFunctions";
const char AnonymousIdentifyToken[] = "AnonymousIdentifyToken";
const char ApplicationDescription[] = "ApplicationDescription";
const char Argument[]        = "Argument";
const char Auditing[]        = "Auditing";
const char BaseDataType[]    = "BaseDataType";
const char BaseDataVariableType[] = "BaseDataVariableType";
const char BaseEventType[]   = "BaseEventType";
const char BaseModelChangeEventType[] = "BaseModelChangeEventType";
const char BaseObjectType[]  = "BaseObjectType";
const char BaseVariableType[] = "BaseVariableType";
const char Boolean[]         = "Boolean";
const char BuildDate[]       = "BuildDate";
const char BuildInfo[]       = "BuildInfo";
const char BuildInfoType[] = "BuildInfoType";
const char BuildNumber[]     = "BuildNumber";
const char Byte[]            = "Byte";
const char ByteString[]      = "ByteString";
const char CurrentTime[]     = "CurrentTime";
const char DataTypeDescriptionType[] = "DataTypeDescriptionType";
const char DataTypeDictionaryType[] = "DataTypeDictionaryType";
const char DataTypeEncodingType[] = "DataTypeEncodingType";
const char DataTypes[]       = "DataTypes";
const char DataTypeSystemType[] = "DataTypeSystemType";
const char DataValue[]       = "DataValue";
const char DateTime[]        = "DateTime";
const char DeleteNodesItem[] = "DeleteNodesItem";
const char DeleteReferencesItem[] = "DeleteReferencesItem";
const char DeviceFailureEventType[] = "DeviceFailureEventType";
const char DiagnosticInfo[]  = "DiagnosticInfo";
const char Double[]          = "Double";
const char Duration[]        = "Duration";
const char Enumeration[]     = "Enumeration";
const char EnumStrings[]     = "EnumStrings";
const char EnableFlag[]      = "EnableFlag";
const char EUInformation[]   = "EUInformation";
const char EventId[]         = "EventId";
const char EventType[]       = "EventType";
const char EventTypes[]      = "EventTypes";
const char ExpandedNodeId[]  = "ExpandedNodeId";
const char Float[]           = "Float";
const char FolderType[]      = "FolderType";
const char FromState[]       = "FromState";
const char GeneratesEvent[]  = "GeneratesEvent";
const char Guid[]            = "Guid";
const char HasCause[]        = "HasCause";
const char HasCondition[]    = "HasCondition";
const char HasChild[]        = "HasChild";
const char HasComponent[]    = "HasComponent";
const char HasDescription[]  = "HasDescription";
const char HasEffect[]       = "HasEffect";
const char HasEncoding[]     = "HasEncoding";
const char HasEventSource[]  = "HasEventSource";
const char HasHistoricalConfiguration[] = "HasHistoricalConfiguration";
const char HasModellingRule[] = "HasModellingRule";
const char HasModelParent[]  = "HasModelParent";
const char HasNotifier[]     = "HasNotifier";
const char HasOrderedComponent[] = "HasOrderedComponent";
const char HasProperty[]     = "HasProperty";
const char HasSubtype[]      = "HasSubtype";
const char HasTypeDefinition[] = "HasTypeDefinition";
const char HierarchicalReferences[] = "HierarchicalReferences";
const char HistoricalEventConfigurationType[] = "HistoricalEventConfigurationType";
const char IdType[]          = "IdType";
const char Image[]           = "Image";
const char ImageBmp[]        = "ImageBmp";
const char ImageGif[]        = "ImageGif";
const char ImageJpg[]        = "ImageJpg";
const char ImagePng[]        = "ImagePng";
const char Int16[]           = "Int16";
const char Int32[]           = "Int32";
const char Int64[]           = "Int64";
const char Integer[]         = "Integer";
const char LocaleId[]        = "LocaleId";
const char LocaleIdArray[]   = "LocaleIdArray";
const char LocalizedText[]   = "LocalizedText";
const char LocalTime[]       = "LocalTime";
const char ManufacturerName[] = "ManufacturerName";
const char MaxBrowseContinuationPoints[] = "MaxBrowseContinuationPoints";
const char MaxHistoryContinuationPoints[] = "MaxHistoryContinuationPoints";
const char MaxQueryContinuationPoints[] = "MaxQueryContinuationPoints";
const char Message[] = "Message";
const char MessageSecurityMode[] = "MessageSecurityMode";
const char ModelChangeStructureDataType[] = "ModelChangeStructureDataType";
const char MinSupportedSampleRate[] = "MinSupportedSampleRate";
const char ModellingRules[]   = "ModelingRules";
const char ModellingRule_CardinalityRestriction[] = "CardinalityRestriction";
const char ModellingRule_ExposesItsArray[] = "ExposesItsArray";
const char ModellingRule_Mandatory[] = "Mandatory";
const char ModellingRule_MandatoryShared[] = "MandatoryShared";
const char ModellingRule_Optional[] = "Optional";
const char ModellingRuleType[] = "ModellingRuleType";
const char NamespaceArray[]  = "NamespaceArray";
const char NamingRule[]      = "NamingRule";
const char NodeClass[]       = "NodeClass";
const char NodeId[]          = "NodeId";
const char NumericRange[]    = "NumericRange";
const char NonHierarchicalReferences[] = "NonHierarchicalReferences";
const char Number[]          = "Number";
const char Objects[]         = "Objects";
const char Server[]          = "Server";
const char ObjectTypes[]     = "ObjectTypes";
const char Organizes[]       = "Organizes";
const char ProductName[]     = "ProductName";
const char ProductURI[]      = "ProductURI";
const char PropertyType[]    = "PropertyType";
const char QualifiedName[]   = "QualifiedName";
const char UtcTime[]         = "UtcTime";
const char Range[]           = "Range";
const char ReceiveTime[]     = "ReceiveTime";
const char RedundancySupport[] = "RedundancySupport";
const char References[]      = "References";
const char ReferenceTypes[]  = "ReferenceTypes";
const char RefreshEndEventType[] = "RefreshEndEventType";
const char RefreshRequiredEventType[] = "RefreshEndEventType";
const char RefreshStartEventType[] = "RefreshStartEventType";
const char Root[]            = "Root";
const char SamplingIntervalDiagnosticsArray[] = "SamplingIntervalDiagnosticsArray";
const char SamplingIntervalDiagnosticsArrayType[] = "SamplingIntervalDiagnosticsArrayType";
const char SamplingIntervalDiagnosticsType[] = "SamplingIntervalDiagnosticsType";
const char SamplingIntervalDiagnosticsDataType[] = "SamplingIntervalDiagnosticsDataType";
const char SByte[]           = "SByte";
const char SecondsTillShutdown[] = "SecondsTillShutdown";
const char SecurityTokenRequestType[] = "SecurityTokenRequestType";
const char SemanticChangeStructureDataType[] = "SemanticChangeStructureDataType";
const char SemanticChangeEventType[] = "SemanticChangeEventType";
const char ServerArray[]     = "ServerArray";
const char ServerCapabilities[] = "ServerCapabilities";
const char ServerCapabilitiesType[] = "ServerCapabilitiesType";
const char ServerDiagnostics[] = "ServerDiagnostics";
const char SessionsDiagnosticsArrayType[] = "SessionsDiagnosticsArrayType";
const char ServerDiagnosticsDataType[] = "ServerDiagnosticsDataType";
const char ServerDiagnosticsType[] = "ServerDiagnosticsType";
const char ServerDiagnosticsSummaryType[] = "ServerDiagnosticsSummaryType";
const char ServerDiagnosticsSummary[] = "ServerDiagnosticsSummary";
const char ServerDiagnosticsVariableType[] = "ServerDiagnosticsVariableType";
const char ServerProfileArray[] = "ServerProfileArray";
const char ServerRedundancy[] = "ServerRedundancy";
const char ServerRedundancyType[] = "ServerRedundancyType";
const char ServerState[]     = "ServerState";
const char ServerStatusDataType[] = "ServerStatusDataType";
const char ServerStatus[] = "ServerStatus";
const char ServerStatusType[] = "ServerStatusType";
const char ServerType[]      = "ServerType";
const char ServerVendorCapabilityType[] = "ServerVendorCapabilityType";
const char ServiceCounterDataType[] = "ServiceCounterDataType";
const char ServiceLevel[]    = "ServiceLevel";
const char SessionSecurityDiagnosticsArrayType[] = "SessionSecurityDiagnosticsArrayType";
const char SessionSecurityDiagnosticsType[] = "SessionSecurityDiagnosticsType";
const char SessionSecurityDiagnosticsDataType[] = "SessionSecurityDiagnosticsDataType";
const char SessionDiagnosticsDataType[] = "SessionDiagnosticsDataType";
const char SessionDiagnosticsObjectType[] = "SessionDiagnosticsObjectType";
const char SessionDiagnosticsSummary[] = "SessionDiagnosticsSummary";
const char SessionDiagnosticsSummaryType[] = "SessionDiagnosticsSummaryType";
const char Severity[]        = "Severity";
const char ShutdownReason[]  = "ShutdownReason";
const char SignedSoftwareCertificate[] = "SignedSoftwareCertificate";
const char SoftwareCertificates[] = "SoftwareSertificates";
const char SoftwareVersion[] = "SoftwareVersion";
const char SourceName[]      = "SourceName";
const char SourceNode[]      = "SourceNode";
const char SubscriptionDiagnosticsArray[] = "SubscriptionDiagnosticsArray";
const char SubscriptionDiagnosticsArrayType[] = "SubscriptionDiagnosticsArrayType";
const char SubscriptionDiagnosticsType[] = "SubscriptionDiagnosticsType";
const char SubscriptionDiagnosticsDataType[] = "SubscriptionDiagnosticsDataType";
const char StartTime[]       = "StartTime";
const char State[]           = "State";
const char StateNumber[]     = "StateNumber";
const char StateType[]       = "StateType";
const char StatusCode[]      = "StatusCode";
const char StatusResult[]    = "StatusResult";
const char String[]          = "String";
const char Structure[]       = "Structure";
const char SystemEventType[] = "SystemEventType";
const char Time[]            = "Time";
const char ToState[]         = "ToState";
const char TransitionType[]  = "TransitionType";
const char Types[]           = "Types";
const char UserNameIdentifyToken[] = "UserNameIdentifyToken";
const char UInteger[]        = "UInteger";
const char UserIdentifyToken[] = "UserIdentifyToken";
const char UInt16[]           = "UInt16";
const char UInt32[]           = "UInt32";
const char UInt64[]           = "UInt64";
const char VariableTypes[]   = "VariableTypes";
const char VendorServerInfo[] = "VendorServerInfo";
const char VendorServerInfoType[] = "VendorServerInfoType";
const char Views[]           = "Views";
const char X509IdentifyToken[] = "X509IdentifyToken";
const char XmlElement[]      = "XmlElement";

}
}

#endif // OPC_UA_STRINGS_H

